<!--
 * @Descripttion: (客服/tb_customer_service)
 * @version: (1.0)
 * @Author: (lwh)
 * @Date: (2023-10-21)
 * @LastEditors: (lwh)
 * @LastEditTime: (2023-10-21)
-->
<template>
  <div class="app-container">
    <el-row :gutter="24">
      <!-- 搜索框 queryParams.需要搜索的字段 -->
      <el-form :model="queryParams" label-position="left" style="margin:15px;"  inline ref="queryForm" v-show="showSearch"
        @submit.prevent>
      <el-form-item label="客服名称" prop="customerServiceName">
        <el-input v-model="queryParams.customerServiceName" placeholder="请输入名称" clearable @keyup.enter="handleQuery"/>
      </el-form-item>
      <el-form-item label="客服电话" prop="customerServicePhone">
        <el-input v-model="queryParams.customerServicePhone" placeholder="请输入电话" clearable @keyup.enter="handleQuery"/>
      </el-form-item>
      <el-form-item>
        <el-button icon="search" type="primary" @click="handleQuery">{{ $t('btn.search') }}</el-button>
        <el-button icon="refresh" @click="resetQuery">{{ $t('btn.reset') }}</el-button>
      </el-form-item>
      </el-form>
    </el-row>

    <!-- 工具按钮 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" v-hasPermi="['business:customerservice:addOrUpdate']" plain icon="plus" @click="AddDialogVisible = true">
          {{ $t('btn.add') }}
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" :disabled="multiple" v-hasPermi="['business:customerservice:delete']" plain icon="delete" @click="handleDelete">
          {{ $t('btn.delete') }}
        </el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <!-- 表格渲染  prop="对应的字段"-->
    <el-table v-loading="loading" :data="dataList" ref="tableRef" border highlight-current-row @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="50" align="center" />
	  
      <el-table-column prop="customerServiceName" label="名称" align="center" :show-overflow-tooltip="true" />
      <el-table-column prop="customerServicePhone" label="电话" align="center" :show-overflow-tooltip="true" />
      <el-table-column prop="customerServiceImg" label="图片" align="center">
        <template #default="scope">
          <el-image preview-teleported :hide-on-click-modal="true" lazy class="table-td-thumb" fit="contain" :src="scope.row.customerServiceImg?.split(',')[0]" :preview-src-list="scope.row.customerServiceImg?.split(',')">
            <div><el-icon :size="15"><document /></el-icon></div>
          </el-image>
        </template>
      </el-table-column>
      <el-table-column prop="workingHoursBeginTime" label="工作时间-上班时间" align="center" :show-overflow-tooltip="true" />
      <el-table-column prop="workingHoursEndTime" label="工作时间-下班时间" align="center" :show-overflow-tooltip="true" />
      <el-table-column prop="customerServiceSort" label="排序" align="center" sortable />

      <el-table-column label="操作" width="350" fixed="right">
        <template #default="scope">
          <el-button type="primary" size="small" icon="edit" @click="handleUpdate(scope.row)"
            v-hasPermi="['business:customerservice:addOrUpdate']">编辑</el-button>
          <el-button type="danger" size="small" icon="delete" @click="handleDelete(scope.row)"
            v-hasPermi="['business:customerservice:delete']">删除</el-button>
          <!-- <el-button size="small" icon="view" @click="handleDetail(scope.row)">查看</el-button> -->
        </template>
      </el-table-column>

    </el-table>
    <pagination :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize"
      @pagination="getList" />
  </div>
  
  <!-- 添加 -->
  <AddDialog v-model="AddDialogVisible" :done="() => resetQuery()"></AddDialog>
  <!-- 编辑 -->
  <EditDialog v-model="EditDialogVisible" :data="EditDialogRow" :done="() => resetQuery()"></EditDialog>
  <!-- 详情 -->
  <DetailDialog v-model="DetailDialogVisible" :data="DetailDialogRow" :done="() => resetQuery()"></DetailDialog>
</template>
<script setup name="customerservice">
import { ElMessageBox } from 'element-plus'
import modal from '@/plugins/modal.js'
import {    customerServiceList , delCustomerService } from '@/api/business/CustomerServices/customerService.js'
import AddDialog from "./components/AddDialog.vue";
import EditDialog from "./components/EditDialog.vue";
import DetailDialog from "./components/DetailDialog.vue";

const AddDialogVisible = ref(false);
const EditDialogVisible = ref(false);
const EditDialogRow = ref({});
const DetailDialogVisible = ref(false);
const DetailDialogRow = ref({});

const { proxy } = getCurrentInstance()

// 选中categoryId数组数组
const ids = ref([])
// 非单选禁用
const single = ref(true)
// 非多个禁用
const multiple = ref(true)
// 显示搜索条件
const showSearch = ref(true)
// 数据列表
const dataList = ref([])
// 总记录数
const total = ref(0)
// 是否加载
const loading = ref(true)

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10
  },
})
const { queryParams } = toRefs(data)

// 业务参数


// 业务方法





//基础方法

// 查询数据
function getList() {
  loading.value = true

                                                                    
  customerServiceList(queryParams.value).then((res) => {
    if (res.code == 200) {
      loading.value = false;
      dataList.value = res.data.result;
      total.value = res.data.totalNum;

      // dataList.value.map((item,idx) => {
      //   item.dateRange = []
        
      //   item.dateRange.push(new Date(item.workingHoursBeginTime))
      //   item.dateRange.push(item.workingHoursEndTime)
      // })
      // console.log(dataList.value,'asdas');
    }
  });
}


// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map((item) => item.customerServiceId)
  single.value = selection.length != 1
  multiple.value = !selection.length
}

/** 重置查询操作 */
function resetQuery() {
  proxy.resetForm('queryForm')
  handleQuery()
}
/** 搜索按钮操作 */
function handleQuery() {
  getList()
}
/** 删除按钮操作 */
function handleDelete(row) {
  const Ids = row.customerServiceId || ids.value

    ElMessageBox.confirm("是否确认删除？", "系统提示", {
      confirmButtonText: '确定',
      cancelButtonText: '取消',
      type: "warning",
    })
    .then(function () {
      return delCustomerService(Ids)
    })
    .then(() => {
      handleQuery()
      modal.msgSuccess("删除成功")
    })
    .catch(() => { })
}



// 修改
function handleUpdate(row) {
  EditDialogVisible.value = true
  EditDialogRow.value = row
}

// 详情
function handleDetail(row) {
  DetailDialogVisible.value = true
  DetailDialogRow.value = row
}

handleQuery()
</script>
